Option Explicit
Const ServiceFilterVersion = "1.1" 
Dim Junk '===> to use MsgBox as fancy .Echo
Junk = MsgBox("ServiceFilter by rand1038" & vbCrLf & _
              "Version: " & ServiceFilterVersion, 64, "ServiceFilter")     
Dim StartTime
StartTime = Timer

'===> Initial setup 
Dim oWShell, oFS
Set oWShell = CreateObject("WScript.Shell")
Set oFS = CreateObject("Scripting.FileSystemObject")

'===> Define special characters in filter file
Dim stCmmnt, stAddRoot, stNameOk, stPathOk
stCmmnt = Chr(35)   '===> comment character
stAddRoot = Chr(62) '===> system root character
stNameOk = "$N$" '===> Nameline identifier
stPathOk = "$P$" '===> Path line identifier

 '===> Double quotes
Dim stQuotes
stQuotes = chr(34)

'===> Get Operating System, NT key does not exist on 9x
On Error Resume Next
Dim stOS
stOS = oWShell.RegRead _
("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\ProductName")
If Err.Number <> 0 Then
   Junk = MsgBox("This Script is intended for" & vbCrLf & _
                 "Windows XP and 2000 only.", 16, "Wrong Operating System")
   HouseCleaning
End If
On Error GoTo 0

'===> Get Current Directory
Dim stCurDir
stCurDir = oFS.GetAbsolutePathName(".")

Dim stFiltDat
If InStr(stOS, "XP") Then stFiltDat = stCurDir & "\Data\XPFilter.dat"
If InStr(stOS, "2000") Then stFiltDat = stCurDir & "\Data\TTFilter.dat"
If stFiltDat = "" Then 
   Junk = MsgBox("This Script is intended for" & vbCrLf & _
                 "Windows XP and 2000 only.", 16, "Wrong Operating System")
   HouseCleaning
End If

'===> Access WMI, check if filter file exists.
'===> Notify user and kill script if errors occur.
Dim oWMI

On Error Resume Next
 Set oWMI = GetObject("winmgmts:")
 If Err.Number <> 0 Then 
    Junk = MsgBox("There was an error accessing Windows" & vbCrLf & _
                  "Management Instrumentation.  Please" & vbCrLf & _
                  "verify that it is installed on your" & vbCrLf & _
                  "system", 16, "WMI Error")
    HouseCleaning
 End If

 Dim oFiltDat
 Set oFiltDat = oFS.OpenTextFile(stFiltDat)
 If Err.Number <> 0 Then FilterError
On Error GoTo 0

'===> Create necessary file srings
Dim stOnlyOnRequest, stPostThis, stDiagOut, stAllServOut
stOnlyOnRequest = stCurDir & "\OnlyOnRequest"
stPostThis = stCurDir & "\POST_THIS.TXT"
stDiagOut = stOnlyOnRequest & "\DiagOut.txt"
stAllServOut = stOnlyOnRequest & "\Services.txt"

'===> Cleanup if script has been run before
If oFS.FolderExists(stOnlyOnRequest) Then oFS.DeleteFolder(stOnlyOnRequest)
If oFS.FileExists(stPostThis) Then oFS.DeleteFile(stPostThis)

'===> Setup sub directory and files to write
Dim oPstThs, oDiagOut, oAllServOut
oFS.CreateFolder(stOnlyOnRequest)
Set oPstThs = oFS.OpenTextFile(stPostThis, 8, True, -2)
Set oDiagOut = oFS.OpenTextFile(stDiagOut, 8, True, -2)
Set oAllServOut = oFS.OpenTextFile(stAllServOut, 8, True, -2)


'===> Get %SystemDrive% and %SystemRoot% then strip drive reference from %SystemRoot%
Dim oEnv, stTmpSysRoot, stSysRoot, stSysDrive
Set oEnv = oWShell.Environment("PROCESS")
stSysDrive = oEnv("SystemDrive")
stTmpSysRoot = oEnv("SystemRoot")
stSysRoot = Replace(stTmpSysRoot, stSysDrive, "", 1, 1)

'===> Create the filter dictionary object
Dim dicFilter
Set dicFilter = CreateObject("Scripting.Dictionary")
dicFilter.CompareMode = vbTextCompare '===> Make dictionary comparisons case insensitive

oDiagOut.WriteLine "##################"
oDiagOut.WriteLine "Building Filter"
oDiagOut.WriteLine "##################"

'===> Read ServiceFilter.dat into dictionary. Strip comments, blank lines
'===> and correct for local Environment
Dim bLeaveName
Dim stNameLine, stPathLine
Dim stNameOut, intPathCounter, stPathOut
'===> Trap script running from zip
On Error Resume Next
With oFiltDat
If Err.Number <> 0 Then 
   Junk = MsgBox("You need to extract the script from the zip file" & vbCrLf & _
                 "before running it.  Right click ServiceFilter.zip" & vbCrLf & _
                 "and choose " & stQuotes & "Extract All", 16, "Cannot run from zip")
   WScript.Quit
End If
On Error GoTo 0

   Do While .AtEndOfStream = False
   bLeaveName = 0 : intPathCounter = 0

      Do 
         If .AtEndOfStream = True Then Exit Do
         If .ReadLine = "[Begin_Section]" Then Exit Do
      Loop 

      Do Until bLeaveName = 1
         If .AtEndOfStream = True Then
            stNameLine = ""
            Exit Do
         End If
         stNameLine = .ReadLine
         stNameLine = Trim(stNameLine)
         FindName '===> subroutine, checks if line is a valid name line.
         If bLeaveName = 1 Then Exit Do
      Loop

      Do
         If .AtEndOfStream = True Then
            stPathLine = ""
            Exit Do
         End If
         stPathLine = .ReadLine
         stPathLine = Trim(stPathLine)
         If stPathLine = "[End_Section]" Then Exit Do
         '===> subroutine, checks if line is a valid path
         '===> and adds local drive and sys root (if necessary).
         FindPath 
      Loop

      '===> Create Dictionary Key/Value if variables contain data.
      If stNameLine = "" Then Exit Do
      If stPathLine = "" Then Exit Do
oDiagOut.WriteLine "NameLine: " & stNameOut
oDiagOut.WriteLine "PathLine: " & LCase(stPathOut)
      dicFilter.Add stNameOut, LCase(stPathOut)

   Loop

   .Close
End With

oDiagOut.WriteLine "####################"
oDiagOut.WriteLine "Done Building Filter"
oDiagOut.WriteLine "####################"

'Get operating system name, version and service pack installed.
Dim colOSInfo, oItem, stCaption, stVersion, stCSDVersion
Set colOSInfo = oWMI.InstancesOf("Win32_OperatingSystem")
For Each oItem in colOSInfo
stCaption = oItem.Caption
stVersion = oItem.Version
stCSDVersion = oItem.CSDVersion
Next

'===> Write Headers
With oPstThs
 .WriteLine "The script did not recognize the services listed below."
 .WriteLine "This does not mean that they are a problem."
 .WriteLine
 .WriteLine "To copy the entire contents of this document for posting:"
 .WriteLine "At the top of this window click " & stQuotes & "Edit" & stQuotes & _
            " then " & stQuotes & "Select All" & stQuotes
 .WriteLine "Next click " & stQuotes & "Edit" & stQuotes & " again then " & stQuotes & _
            "Copy" & stQuotes
 .WriteLine "Now right click in the forum post box then click " & stQuotes & _
            "Paste" & stQuotes
 .WriteLine
 .WriteLine (string(40, 35)) '===> Write a line of 40 # signs
 .WriteLine
 .WriteLine "ServiceFilter " & ServiceFilterVersion
 .WriteLine "by rand1038"
 .WriteLine
 .WriteLine stCaption
 .WriteLine "Version: " & stVersion & " " & stCSDVersion
 .WriteLine MonthName(Month(NOW), True) & " " & Day(NOW) & ", " & Year(Now) & " " & Time
 .WriteLine
 .WriteLine
End With

With oAllServOut
 .WriteLine (string(51, 35))
 .WriteLine
 .WriteLine "Please do not post the contents of this document"
 .WriteLine "unless the person helping you specifically requests"
 .WriteLine "to see Services.txt"
 .WriteLine "Thank You"
 .WriteLine
 .WriteLine (string(51, 35))
 .WriteLine
 .WriteLine "ServiceFilter " & ServiceFilterVersion
 .WriteLine "by rand1038"
 .WriteLine
End With

'===> Get services collection
Dim colServices, oService
Set colServices = oWMI.InstancesOf("Win32_Service")

 '===> Loop through services collection, writing to Services.txt and POST_THIS.txt
 '===> as necessary
Dim stSvName, stSvDisplayName, stSvStartMode, stSvStartName, stSvDescription
Dim stSvServiceType, stSvPathName, stPathNameMod, stSvState, stSvProcessID
Dim stSvStarted, stSvExitCode, stSvAcceptPause, stSvAcceptStop
Dim cServ, Unknown, intCLSID, stFiltFlag
Dim oCatchAll

For Each oService in colServices
   stSvName = Trim(oService.Name)
   stSvDisplayName = oService.DisplayName
   stSvStartMode = oService.StartMode
   stSvStartName = oService.StartName
   '===> stSvDescription = oService.Description
   stSvServiceType = oService.ServiceType
   '===> stSvPathName = oService.PathName
   stSvState = oService.State
   stSvProcessID = oService.ProcessID
   stSvStarted = oService.Started
   stSvExitCode = oService.ExitCode
   stSvAcceptPause = oService.AcceptPause
   stSvAcceptStop = oService.AcceptStop

   '===> Cut length of description to around 100 characters
   stSvDescription = oService.Description  
   stSvDescription = Trim(Left(stSvDescription, 100))
   If InStr(stSvDescription, Chr(32)) > 0 Then
      stSvDescription = Left(stSvDescription, InStrRev(stSvDescription, Chr(32)))
   End If

   '===> Modify path to exclude quotation marks
   stSvPathName = Trim(LCase(oService.PathName))
   stPathNameMod = stSvPathName   
   If IsNull(stPathNameMod) Then 
      stPathNameMod = "EmptyPath"
   ElseIf Len(stPathNameMod) < 2 Then
      stPathNameMod = "EmptyPath"
   Else
      stPathNameMod = Replace(stPathNameMod, stQuotes, "")
   End If

   cServ = cServ + 1 '===> Count Services

   '==> Write contents of variables to Services.txt
   Set oCatchAll = oAllServOut
   WriteService
   Set oCatchAll = Nothing   

   '===> check Name and PathName against known good combinations
   stFiltFlag = "Empty"
   If dicFilter.Exists(stSvName) Then 
      stFiltFlag = "name"
      If InStr(1, dicFilter.Item(stSvName), stPathNameMod, 1) Then 
         stFiltFlag = stFiltFlag & "_path"
      End If
   End If

   '===> Wrire to diagnostic file
   With oDiagOut
    .WriteLine "stFiltFlag: " & stFiltFlag
    .WriteLine "Service Name: " & stSvName
    .WriteLine "Path Name:    " & stSvPathName
    .WriteLine "PathNameMod:  " & stPathNameMod
    .WriteLine
   End With	

   Set oCatchAll = oPstThs
   '===> Write to POST_THIS.TXT if necessary 
   Select Case stFiltFlag
   Case "name"
    If Unknown = 0 Then
       oCatchAll.WriteLine "===> Begin Service Listing <==="
       oCatchAll.WriteLine
    End If
    Unknown = Unknown + 1
    oCatchAll.WriteLine "Unknown Service #" & Unknown
    WriteService
   Case "name_path"
    '===> Take no action, its a match
   Case "Empty"
    If Unknown = 0 Then
       oCatchAll.WriteLine "---> Begin Service Listing <---"
       oCatchAll.WriteLine
    End If
    Unknown = Unknown + 1
    oCatchAll.WriteLine "Unknown Service # " & Unknown
    WriteService
   Case Else
    WScript.Echo "Error in Select Case"
    HouseCleaning
   End Select
   Set oCatchAll = Nothing

Next

If Unknown < 1 Then
   oPstThs.WriteLine "There are " & cServ & " Win32 services on this machine."
   oPstThs.WriteLine "All were recognized as legitimate."
ElseIf Unknown > 0 Then
   oPstThs.WriteLine "---> End Service Listing <---"
   oPstThs.WriteLine
   oPstThs.WriteLine "There are " & cServ & " Win32 services on this machine."
   oPstThs.WriteLine Unknown & " were unrecognized."
End If

Dim EndTime
EndTime = Timer - StartTime
oDiagOut.WriteLine 
oDiagOut.WriteLine "Script Execution Time: " & EndTime & " seconds."
oPstThs.WriteLine
oPstThs.WriteLine "Script Execution Time: " & EndTime & " seconds."

'===> Let the user know the script is done and a doc will open	
Junk = MsgBox("All done!" & vbCrLf & vbCrLf & _
	     "a copy of " & stQuotes & "POST_THIS.TXT" & stQuotes & " will open, please copy the contents and paste" & vbCrLf & _
	     "them as a reply to the topic where you are being helped. There is also a" & vbCrLf & _
	     "copy in the same folder as this script, if you need to access it manually." & vbCrLf & _
	     "Thank You.", 64, "Operations Complete")

'===> Open POST_THIS.txt, let the user know if there was a problem doing so.
On Error Resume Next
oWShell.Run "WordPad " & stQuotes & stPostThis & stQuotes, 3, False 
If Err.Number <> 0 Then
   Junk = MsgBox("There was a problem accessing Wordpad, please" & vbCrLf & _
                 "manually open POST_THIS.TXT", 64, "Error Accessing Wordpad")
End If
HouseCleaning
On Error GoTo 0

WScript.Echo("Script Error, went past end of code.")
HouseCleaning

'===> ###############
'===> # Subroutines 
'===> ###############

Sub FindName
 If stNameLine = "" Then Exit Sub
 If Left(stNameLine, 1) = stCmmnt Then Exit Sub
 If InStr(stNameLine, stNameOk) < 1 Then FilterError
 stNameOut = Trim(Replace(stNameLine, "$N$", ""))
 bLeaveName = 1
End Sub

Sub FindPath 
 If stPathLine = "" Then Exit Sub
 If Left(stPathLine, 1) = stCmmnt Then Exit Sub
 If InStr(stPathLine, stPathOk) < 1 Then FilterError
 stPathLine = Replace(stPathLine, stAddRoot, stSysRoot, 1, 1)
 stPathLine = stSysDrive & stPathLine
 stPathLine = Replace(stPathLine, stQuotes, "")
 stPathLine = Trim(Replace(stPathLine, "$P$", ""))
 stPathLine = stQuotes & stPathLine & stQuotes
 intPathCounter = intPathCounter + 1
 If intPathCounter < 2 Then
   stPathOut = stPathLine
 Else
   stPathOut = stPathOut & " " & stPathLine
 End If
End Sub

Sub WriteService
 With oCatchAll
   .WriteLine "Service Name: " & stSvName
   .WriteLine "Display Name: " & stSvDisplayName
   .WriteLine "Start Mode: " & stSvStartMode
   .WriteLine "Start Name: " & stSvStartName
   .WriteLine "Description: " & stSvDescription & "..."
   .WriteLine "Service Type: " & stSvServiceType
   .WriteLine "Path: " & stSvPathName
   .WriteLine "State: " & stSvState
   .WriteLine "Process ID: " & stSvProcessID
   .WriteLine "Started: " & stSvStarted
   .WriteLine "Exit Code: " & stSvExitCode
   .WriteLine "Accept Pause: " & stSvAcceptPause
   .WriteLine "Accept Stop: " & stSvAcceptStop
   .WriteLine
 End With
End Sub

Sub FilterError '===> If filter file is corrupt
 oPstThs.Close
 oFS.DeleteFile(stPostThis) 
 Junk = MsgBox("There was a problem processing the filter file." & vbCrLf & _
               "It appears to be corrupted.  Please delete the" & vbCrLf & _
               "ServiceFilter folder and download a fresh copy." & vbCrLf & _
               "If the problem reoccurs, please bring it to the" & vbCrLf & _
               "attention of the person helping you.", 16, "Filter Population Error")
 HouseCleaning
End Sub

Sub HouseCleaning '===> May execute before all of these objects are instantiated,
 On Error Resume Next ' needs errors ignored
 oPstThs.Close
 oAllServOut.Close
 oDiagOut.Close
 dicFilter.RemoveAll
 Set dicFilter = Nothing
 Set oFS = Nothing
 Set oWShell = Nothing
 Set colServices = Nothing
 WScript.Quit
End Sub
